/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.sample.expenses.gwt.request;

import com.google.gwt.valuestore.shared.ValuesKey;

/**
 * "API Generated" base interface for proxy keys to
 * {@link com.google.gwt.valuestore.shared.Values Values} of
 * {@link com.google.gwt.sample.expenses.server.domain}.
 * <p>
 * IRL this class will be generated by a JPA-savvy tool run before compilation.
 *
 * @param <K> this entity type
 */
public interface ExpensesKey<K extends ExpensesKey<K>> extends ValuesKey<K> {
  void accept(ExpensesKeyVisitor visitor);

  <T> T accept(ExpensesKeyFilter<T> filter);
}
